//+------------------------------------------------------------------+
//|                                                  userTextVar.mqh |
//|                                                Lorentzos Roussos |
//|                              https://www.mql5.com/en/users/lorio |
//+------------------------------------------------------------------+
#property copyright "Lorentzos Roussos"
#property link      "https://www.mql5.com/en/users/lorio"
#ifndef USERTEXTVAR
struct user_text_var
{
ushort text[];
int    text_size;

user_text_var(void){reset();}
user_text_var(string user_text){reset();from_string(user_text);}

void reset(){text_size=0;ArrayFree(text);}

void from_string(string user_text){
text_size=0;
if(StringLen(user_text)>0){
ArrayResize(text,StringLen(user_text),0);
for(int c=0;c<StringLen(user_text);c++){
text_size++;
text[text_size-1]=StringGetCharacter(user_text,c);
}}}

bool is_same(user_text_var &other){
bool same=false;
if(other.text_size==text_size&&text_size>0){
same=true;
for(int t=0;t<text_size;t++){if(text[t]!=other.text[t]){same=false;break;}}
}
return(same);
}

bool is_same(string user_text){
user_text_var temp(user_text);
return(is_same(temp));
}

void save(int file_handle){
FileWriteInteger(file_handle,text_size,INT_VALUE);
if(text_size>0){FileWriteArray(file_handle,text,0,text_size);}
}

void load(int file_handle){
reset();
text_size=(int)FileReadInteger(file_handle,INT_VALUE);
if(text_size>0){ArrayResize(text,text_size,0);FileReadArray(file_handle,text,0,text_size);}
}

void operator=(string user_text){from_string(user_text);}
bool operator==(string user_text){return(is_same(user_text));}
bool operator!=(string user_text){return(!is_same(user_text));}
bool operator==(user_text_var &other){return(is_same(other));}
bool operator!=(user_text_var &other){return(!is_same(other));}
string to_string(){return(ShortArrayToString(text,0,text_size));}
};
#define USERTEXTVAR 5171
#endif 
